//PsychicForceL1.cs


datablock AudioProfile(PsychicForceL1ExplosionSound)
{
   filename    = "./SpellArrowHit.wav";
   description = AudioClose3d;
   preload = false;
};

datablock AudioProfile(PsychicForceL1FireSound)
{
   filename    = "./SpellArrowFire.wav";
   description = AudioClose3d;
   preload = true;
};


//PsychicForceL1 trail
datablock ParticleData(PsychicForceL1TrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 500;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 1000.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "./sparkspin";
	//animTexName		= "./dot";

	// Interpolation variables
	colors[0]     = "1.0 0.0 1.0 0.8";
   	colors[1]     = "1.0 0.0 1.0 0.8";
	sizes[0]	= 0.3;
	sizes[1]	= 0.2;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(PsychicForceL1TrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;

   ejectionVelocity = 1; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = PsychicForceL1TrailParticle;
};

//PsychicForceL1 trail2
datablock ParticleData(PsychicForceL1TrailParticle2)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 700;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 1000.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "./sparkspin";
	//animTexName		= "./dot";

	// Interpolation variables
	colors[0]     = "1.0 0.0 1.0 0.8";
   	colors[1]     = "1.0 0.0 1.0 0.8";
	sizes[0]	= 0.1;
	sizes[1]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(PsychicForceL1TrailEmitter2)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = PsychicForceL1TrailParticle2;
};


//effects
datablock ParticleData(PsychicForceL1ExplosionParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.5;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 1.0;
	lifetimeMS		= 900;
	lifetimeVarianceMS	= 300;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "./sparkspin";
	//animTexName		= "./sparkspin";

	// Interpolation variables
	colors[0]     = "1.0 0.0 1.0 0.8";
   	colors[1]     = "1.0 0.0 1.0 0.8";
	sizes[0]	= 1.8;
	sizes[1]	= 1.0;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(PsychicForceL1ExplosionEmitter)
{
   ejectionPeriodMS = 9;
   periodVarianceMS = 0;
   lifeTimeMS	   = 21;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PsychicForceL1ExplosionParticle";
};

datablock ParticleData(PsychicForceL1ExplosionParticle2)
{
	dragCoefficient		= 0.1;
	windCoefficient		= 0.0;
	gravityCoefficient	= 2.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1000;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "./sparkspin";
	//animTexName		= "./sparkspin";

	// Interpolation variables
	colors[0]     = "1.0 0.0 1.0 0.8";
   	colors[1]     = "1.0 0.0 1.0 0.8";
	sizes[0]	= 0.8;
	sizes[1]	= 0.5;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(PsychicForceL1ExplosionEmitter2)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   lifetimeMS       = 10;
   ejectionVelocity = 15;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PsychicForceL1ExplosionParticle2";
};

datablock ExplosionData(PsychicForceL1Explosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = PsychicForceL1ExplosionSound;

   emitter[0] = PsychicForceL1ExplosionEmitter;
   emitter[1] = PsychicForceL1ExplosionEmitter2;
   particleDensity = 5000;
   particleRadius = 10.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 4;
   lightEndRadius = 3;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 0;
   impulseForce = 2000;

   //radius damage
   radiusDamage        = 0;
   damageRadius        = 3.5;
};

//projectile
datablock ProjectileData(PsychicForceL1Projectile)
{
   projectileShapeName = "./arrow.dts";
   directDamage        = 5;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = PsychicForceL1Explosion;
   particleEmitter     = PsychicForceL1TrailEmitter;
   particleEmitter2    = PsychicForceL1TrailEmitter2;

   brickExplosionRadius = 0;
   brickExplosionImpact = true; //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;
   brickExplosionMaxVolumeFloating = 0;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 20000;
   fadeDelay           = 19500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

     //burn the players?
   playerBurnTime = 5000;

   uiName = "PsychicForceL1";
};


//////////
// item //
//////////
datablock ItemData(PsychicForceL1Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./EmptyHand.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "PsychicForce L1-15";
	iconName = "./Rapid_Icon";
	doColorShift = true;
	colorShiftColor = "1.0 0.0 1 1.000";

	 // Dynamic properties defined by the scripts
	image = PsychicForceL1Image;
	canDrop = true;
};

//function PsychicForceL1::onUse(%this,%user)
//{
//	//mount the image in the right hand slot
//	%user.mountimage(%this.image, $RightHandSlot);
//}

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(PsychicForceL1Image)
{
   // Basic Item properties
   shapeFile = "./EmptyHand.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 -0.5";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = PsychicForceL1Item;
   ammo = " ";
   projectile = PsychicForceL1Projectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "1.0 0.0 1 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 0.1;
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateScript[2]                  = "onCharge";
	stateAllowImageChange[2]        = false;
	
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0.3;
	stateWaitForTimeout[3]		= true;
	stateScript[3]			= "onAbortCharge";
	stateAllowImageChange[3]	= false;

	stateName[4]			= "Armed";
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateAllowImageChange[4]	= false;

	stateName[5]			= "Fire";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.1;
	stateFire[5]			= true;
	stateSequence[5]		= "fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;
	stateSound[5]				= PsychicForceL1FireSound;
};

function PsychicForceL1Image::onCharge(%this, %obj, %slot)
{
	//messageAll( 'MsgClient', 'PsychicForceL1 prefired!!!');
	Parent::onFire(%this, %obj, %slot);
	%obj.playthread(2, rotCW);
}

function PsychicForceL1Image::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function PsychicForceL1Image::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, SpearThrow);
	Parent::onFire(%this, %obj, %slot);
}
function Player::stopBurn(%this)
{
	%this.isBurning=0;
}

function CobraProjectile::onCollision(%this,%obj,%col,%pos,%fade)
{
	if(%col.getClassName() $= "Player" && %col.isBurning !$= 1 && miniGameCanDamage(%obj.client, %col) $= 1)
	{
		%col.isBurning=1;
		%col.schedule(8000,"stopBurn");
		%col.emote(playerNapalmBurnImage);
		%col.schedule(1000,"emote",playerBurnImage);
		%col.schedule(500,"setTempColor","0 0 0 1",5200);
		%col.schedule(5000,"burn");
	}
	Parent::onCollision(%this,%obj,%col,%pos,%fade);
}


